#ifndef WVISCSOLVER_H
#define WVISCSOLVER_H

#include "dart.h"
#include "wBLRegion.h"

namespace dart
{

class DART_API ViscSolver
{
public:
  double Cdt;
  double Cdf;
  double Cdp;

private:
  double Re;
  double Minf;
  double CFL0;

  TimeSolver *tSolver;

public:
  std::vector<BLRegion *> bl;

  ViscSolver(double _Re, double _Minf, double _CFL0);

  ~ViscSolver();
  void InitMeshes(size_t region, std::vector<double> locM, std::vector<double> globM);
  void SendInvBC(size_t region, std::vector<double> _Ue,
                               std::vector<double> _Me,
                               std::vector<double> _Rhoe);
  void SendExtVariables(size_t region, std::vector<double> _xxExt, std::vector<double> _deltaStarExt);


  int Run(unsigned int couplIter);

private:
  void CheckWaves(size_t iPoint, BLRegion *bl);
  void AverageTransition(size_t iPoint, BLRegion *bl, int forced);
  void ComputeDrag();

};
} // namespace dart
#endif //WVISCSOLVER_H